/**
 * Card Class represents A class 
 */

import java.util.ArrayList;

public abstract class Card {
    protected String name;
    protected String color;
    private int score;
    public static final String set = "\u001B[0m";
    public static final String green = "\u001B[32m";
    public static final String red = "\u001B[31m";
    public static final String yellow = "\u001B[33m";
    public static final String blue = "\u001B[34m";


    public Card() {
    }

    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }

    public Card(int score) {
        this.score = score;
    }

    public int getScore() {
        return score;
    }

    public void setScore(int score) {
        this.score = score;
    }


    public abstract String toString();

    public abstract void print();

    public abstract User act(User chosenUser, int numOfChosenCard ,ArrayList<User> users, ArrayList<Card> remainingCards, Card upperCard);

    public boolean isAvailableToPut( User chosenUser, Card upperCard) {

        if (this.getScore() < 10 && upperCard.getScore() < 10){
            NumericalCard upper = (NumericalCard)upperCard;
            NumericalCard chosen = (NumericalCard)this;
            if (color.equals(upper.getColor()) || chosen.getNumber() == upper.getNumber()){
                return true;
            }
            else
                return false;
        }
        else if (this.getScore() < 50 && upperCard.getScore() < 50) {
            if ((this instanceof SkipCard && upperCard instanceof SkipCard) ||(this instanceof ReverseCard && upperCard instanceof ReverseCard)){
                //you can put a reverse card after a reverse card
                //you can put a skip card after a skip card
                return true;
            }
            ColoredCard upper = (ColoredCard) upperCard;
            if (this.getColor().equals(upper.getColor()))
                return true;
            else
                return false;
        } else {
            for (Card card : chosenUser.getUserCards()) {
                if (card instanceof WildCard){
                    continue;
                }
                else {//if there is another card to choose you can not choose wild card
                    if (card.isAvailableToPut( chosenUser , upperCard)) {
                        return false;
                    }
                }
            }
            return true;
        }

    }
}
